/**
* @author   Vasatko
* @version  1.0
* @remarks  Copyright (C) 2011 Vasatko
* @remarks  Licensed under GNU/GPLv3, see http://www.gnu.org/licenses/gpl-3.0.html
* @see      http://vasatko.net/joomla/mapycz
*/
	
	// init values
	var mapycz_saved = true;
	var mapycz_initCall = true;
	var MAPYCZ_MAP_SAVED = "map saved";
	var MAPYCZ_MARK_NOT_SAVED_MAP = "You must save map first!";
	var MAPYCZ_MAP_NOT_SAVED_EXIT = "Map not saved, realy exit?";

	// open modal box
	function mapycz_openWindow(url,closeAction,openAction){
		SqueezeBox.open('',{url: url, classWindow: '', handler:'iframe', size: {x: 800, y: 600}, onOpen:function(){setTimeout(openAction,1);}, onClose:function(){setTimeout(closeAction,1);},ajaxOptions:{evalScripts: true}});	
	}
		
	// check if map seved
	function mapycz_checkSave(){

		return mapycz_saved;
	}
	
	// save map data and markers positions
	function mapycz_saveMap(token){
		
		if(!mapycz_mapFormValidator || !mapycz_mapFormValidator.validate())
			return false;
		
		if(!mapycz_mapFormState){
			return false;
		}
		
		var id = $('mapycz_id').value;
		
		if(id)
			mapycz_saveMapMark($('mapycz_id').value)
		
		temp=new Element('div');
		temp.innerHTML=token;
		token=temp.getElement('input').getProperty('name');
		
		var data = token+'=1&';
		data += 'cid='+$('mapycz_id').value+'&';
		data += 'name='+$('mapycz_name').value+'&';
		data += 'width='+$('mapycz_width').value+'&';
		data += 'height='+$('mapycz_height').value+'&';
		data += 'controls='+(($('mapycz_controls').checked)?'on':'off')+'&';
		data += 'zoom='+$('mapycz_zoom').value+'&';
		data += 'layer='+$('mapycz_layer').value+'&';
		data += 'latitude='+$('mapycz_latitude').value+'&';
		data += 'longitude='+$('mapycz_longitude').value;
		
		new Request({
		    url: mapycz_uri_admin+'/index.php?option=com_mapycz&task=save',
		    async: true,
		    method: 'post',
		    data: data,
		    onSuccess: function(responseText, responseXML){
			    
			    mapycz_saved = true;
			    
			    if(!id){
			    	temp=new Element('div');
					temp.innerHTML=responseText;
					id=temp.getElementById('newMapId').innerHTML;
					location.replace(mapycz_uri_admin+"/index.php?option=com_mapycz&task=show&cid="+id);
			    }
			    
			    SqueezeBox.open('',{handler:'iframe', classWindow: 'echo ok', size: {x: 200, y: 20}});
			    SqueezeBox.applyContent(MAPYCZ_MAP_SAVED);
			    setTimeout("SqueezeBox.close();",1000);
		    }
		}).send();
	}

	// save mark data
	function mapycz_saveMarker(){
		
		if(!mapycz_markFormValidator || !mapycz_markFormValidator.validate()) 
			return false;
		
		if(!mapycz_markFormState){
			return false;
		}
		
		temp=new Element('div');
		temp.innerHTML=mapycz_markToken;
		token=temp.getElement('input').getProperty('name');
		
		var colors=document.mapMarkForm.color;
		for( i = 0; i < colors.length; i++ ){
			if( colors[i].checked == true )
				color = colors[i].value;
		}
		
		var data = token+'=1&';
		data += 'cid='+$('mapycz_mark_mark').value+'&';
		data += 'shortcut='+$('mapycz_mark_shortcut').value+'&';
		data += 'title='+$('mapycz_mark_title').value+'&';
		data += 'color='+color+'&';
		data += 'text='+getMarkText()+'&';
		data += 'longitude='+$('mapycz_mark_lon').value+'&';
		data += 'latitude='+$('mapycz_mark_lat').value+'&';
		data += 'mapId='+$('mapycz_mark_map').value;
		
		new Request({
		    url: mapycz_uri_admin+'/index.php?option=com_mapycz&task=marker.save',
		    async: true,
		    method: 'post',
		    data: data,
		    onSuccess: function(responseText, responseXML){
		    	var btn = window.parent.document.getElementById('sbox-btn-close');
				btn.fireEvent('click');
		    }
		}).send();
	}
	
	var mapycz_mapFormValidator=null;
	var mapycz_markFormValidator=null;
	var mapycz_mapFormState = true;
	var mapycz_markFormState = true;
	
	window.addEvent('domready',function() {
		Locale.use(mapycz_locale);
	    mapycz_mapFormValidator = new Form.Validator.Inline($('map-form'),{
	    	onFormValidate: function(){
	    		mapycz_mapFormState = true;
	    	},
	    	onElementFail: function(){
	    		mapycz_mapFormState = false;
	    	}
	    });
	});
	
	function mapycz_markInit(){
		Locale.use(mapycz_locale);
    	mapycz_markFormValidator = new Form.Validator.Inline($('map-mark-form'),{
    		onFormValidate: function(){
    			mapycz_markFormState = true;
    		},
    		onElementFail: function(){
    			mapycz_markFormState = false;
    		}
    	});
	}
	
	// get selected marker
	function mapycz_getSelectedMarkers(){
		
		var result = new Array();
		var i=0;
		$("adminForm").getElements("input[name='cid[]']").each(function(el){
			if(el.checked){
				result[i]=el.value;
				i++;
			}
		});
		
		return result;
	}
	
	// edit first of selected marker
	function mapycz_editMarker(marker,mapId){
		
		if(!mapycz_checkSave()){
			alert(MAPYCZ_MARK_NOT_SAVED_MAP);
			return false;
		}
		
		// if array, then select first
		if(marker.constructor == Array){
			marker=marker[0];
		}
		
		mapycz_openWindow(mapycz_uri_admin+'/index.php?option=com_mapycz&task=marker.edit&mapId='+mapId+'&markerId='+marker,'mapycz_loadMarkers(\''+mapId+'\');');
		
	}

	// delete all selected markers
	function mapycz_deleteMarker(mapId){
		
		if(!mapycz_checkSave()){
			alert(MAPYCZ_MARK_NOT_SAVED_MAP);
			return false;
		}
		
		var data='';
		var i=0;
		mapycz_getSelectedMarkers().each(function(id){
			data += 'cid['+i+']='+id+'&';
			i++;
		});
		data += 'mapId='+mapId;
		
		new Request({
		    url: mapycz_uri_admin+'/index.php?option=com_mapycz&task=marker.delete',
		    async: false,
		    method: 'post',
		    data: data,
		    onSuccess: function(responseText, responseXML){
		    	mapycz_loadMarkers(mapId);
		    }
		}).send();
		
	}
	
	// load marker list to the map detail
	function mapycz_loadMarkers(mapId){
		
		new Request({
		    url: mapycz_uri_admin+'/index.php?option=com_mapycz&task=markers&mapId='+mapId,
		    async: false,
		    noCache: true,
		    evalScripts: true,
		    onSuccess: function(responseText, responseXML){
			    var marksbox = $('mapycz-map-marks');	
			    marksbox.innerHTML = responseText.getTags('body',true);
			    mapycz_loadMapMark();
		    }
		}).send();
	}
	
	// (re)load all markers to map 
	function mapycz_loadMapMark(){
		
		// remove all markers
		layMarker.removeAll();
		
		// for each marker
		var i=1;
		$("adminForm").getElements("input[name='cid[]']").each(function(el){
				
			var id = el.value;
			var shr = $('mapycz_marker'+id+'_shortcut').innerHTML.trim();
			var tit = $('mapycz_marker'+id+'_title').innerHTML.trim();
			var lon = $('mapycz_marker'+id+'_longitude').innerHTML.trim();
			var lat = $('mapycz_marker'+id+'_latitude').innerHTML.trim();
			var col = $('mapycz_marker'+id+'_color').innerHTML.trim();
			if(col=='')
				col='red';
			i++;
			
			var markerCoords = SMap.Coords.fromWGS84(lat,lon);
			var markerBox = JAK.mel('div');
			var markerImg = JAK.mel('img', {src:mapycz_uri_admin+'/components/com_mapycz/assets/images/marker-'+col+'.png'});
			markerBox.appendChild(markerImg);
			var markerTxt = JAK.mel('div', {}, {position:'absolute', left:'0px', top:'3px', textAlign:'center', width:'22px', color:'white', fontWeight:'bold', fontSize:'11px'});
			markerTxt.innerHTML = shr;
			markerBox.appendChild(markerTxt);
			var marker = new SMap.Marker(markerCoords, 'mapycz_marker'+id, {url:markerBox});
			marker.decorate(SMap.Marker.Feature.Draggable);
			layMarker.addMarker(marker);
			
		});
		
	}
	
	// (re)save all mark positions
	function mapycz_saveMapMark(mapId){
		
		if($("adminForm").getElements("input[name='cid[]']").length<=0)
			return;
		
		var data='';
		
		$("adminForm").getElements("input[name='cid[]']").each(function(el){
			
			var id = el.value;
			var lon = $('mapycz_marker'+id+'_longitude').innerHTML.trim();
			var lat = $('mapycz_marker'+id+'_latitude').innerHTML.trim();
			
			data += 'marker['+id+'][lon]='+lon+'&';
			data += 'marker['+id+'][lat]='+lat+'&';
			
		});
		
		data += 'mapId='+mapId;
		
		new Request({
		    url: mapycz_uri_admin+'/index.php?option=com_mapycz&task=marker.massSavePosition',
		    async: false,
		    method: 'post',
		    data: data,
		    onSuccess: function(responseText, responseXML){
			    //alert(responseText);
		    }
		}).send();
		
	}
	
	function mapycz_markerDragStop(e){
		
		mapycz_saved = false;
		
		var id = e.target.getId()
		
		var node = e.target.getContainer();
		node[SMap.LAYER_MARKER].style.cursor = '';
		
		var poz = e.target.getCoords().toWGS84();
		poz = poz + '';
	
		var poz_x = poz.substr(0,poz.indexOf(','));
		var poz_y = poz.substr(poz.indexOf(',')+1,poz.length);
	
		$(id+'_latitude').innerHTML = poz_x;
		$(id+'_longitude').innerHTML = poz_y;
	 
	}
	
	function mapycz_mapChange(){
		
		if(mapycz_initCall){
			mapycz_initCall=false;
		}else{
			mapycz_saved = false;
		}
		
		if(map.getLayer(SMap.DEF_TURIST).isActive())
			layer = 'turist';
		else if(map.getLayer(SMap.DEF_OPHOTO).isActive())
			layer = 'ophto';
		else if(map.getLayer(SMap.DEF_OPHOTO0203).isActive())
			layer = 'ophto0203';
		else if(map.getLayer(SMap.DEF_OPHOTO0406).isActive())
			layer = 'ophto0406';
		else if(map.getLayer(SMap.DEF_HISTORIC).isActive())
			layer = 'historic';
		else
			layer = 'base';
		$('mapycz_layer').value = layer;
		
		var zoom = map.getZoom();
		$('mapycz_zoom').value = zoom;
	
		var poz = map.getCenter().toWGS84();
		poz = poz + '';
	
		var poz_x = poz.substr(0,poz.indexOf(','));
		var poz_y = poz.substr(poz.indexOf(',')+1,poz.length);
	
		$('mapycz_latitude').value = poz_x;
		$('mapycz_longitude').value = poz_y;
		
	}
	
	function mapycz_mapSizeChange(){
		
		mapycz_saved = false;
	
		var width = $('mapycz_width').value;
		var height = $('mapycz_height').value;
		
		//if(width>850) width = 850;
		//if(height>550) height = 550;
		
		$('mapycz_width').value = width;
		$('mapycz_height').value = height;
		$('mapycz').style.width = width + 'px';
		$('mapycz').style.height = height + 'px';
	}