<?php
/**
* @author   Vasatko
* @version  1.0
* @remarks  Copyright (C) 2011 Vasatko
* @remarks  Licensed under GNU/GPLv3, see http://www.gnu.org/licenses/gpl-3.0.html
* @see      http://vasatko.net/joomla/mapycz
*/

// no direct access
defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT.'/helpers/html');
JHtml::_('behavior.tooltip');

$listOrder	= $this->state->get('list.ordering');
$listDirn	= $this->state->get('list.direction');
$saveOrder	= $listOrder == 'm.ordering';

$js="";
?>

<div class="border">
	<div class="padding">
		<div id="toolbar-box">
			<div class="t">
				<div class="t">
					<div class="t"></div>
				</div>
			</div>
			
			<div class="m">
				
				<h2 style="float:left;"><?=JText::_('MAPYCZ_MARK_LABEL')?></h2>
				
				<div id="toolbar" class="toolbar-list">
					<ul>
						<?=	MapyczHelper::button(
								"new", 
								JText::_("MAPYCZ_MARK_ADD"), 
								"index.php?option=com_mapycz&amp;task=marker.add&amp;mapId=".$this->map->id,
								"if(!mapycz_checkSave()){alert(MAPYCZ_MARK_NOT_SAVED_MAP);return false;}",
								"mapycz_loadMarkers(\'".$this->map->id."\');"
							)?>
						
						<?=	MapyczHelper::button(
								"trash", 
								JText::_("MAPYCZ_MARK_DELETE"), 
								"",
								"mapycz_deleteMarker('".$this->map->id."');return false;",
								""
							)?>
					</ul>
				</div>
				
				<div class="clr"></div>
					
				<?=JText::_('MAPYCZ_MARK_DESC')?><br/><br/>

				<form action="<?php echo JRoute::_('index.php?option=com_mapycz&task=markers'); ?>" method="post" name="adminForm" id="adminForm">
					<table class="adminlist mapycz">
						<thead>
							<tr>
								<th width="1%">
									<input type="checkbox" name="checkall-toggle" value="" onclick="checkAll(this)" />
								</th>
								<th>
									<?php echo JText::_('MAPYCZ_FIELD_ID'); ?>
								</th>
								<th>
									<?php echo JText::_('MAPYCZ_MARK_FIELD_SHORTCUT'); ?>
								</th>
								<th>
									<?php echo JText::_('MAPYCZ_MARK_FIELD_TITLE'); ?>
								</th>
							</tr>
						</thead>
						<tbody>
							<? 
							$n = count($this->items);
							foreach ($this->items as $i => $item) :
								$ordering	= $listOrder == 'm.ordering';
								$js.="alert('".$this->escape($item->shortcut)."');";
								?>
								<tr class="row<?php echo $i % 2; ?>">
									<td class="center">
										<?php echo JHtml::_('grid.id', $i, $item->id); ?>
									</td>
									<td align="right">
										<a href="#" onclick="mapycz_editMarker('<?=$item->id?>','<?=$this->map->id?>');return false;"><?php echo $this->escape($item->id); ?></a>
									</td>
									<td align="left">
										<a href="#" onclick="mapycz_editMarker('<?=$item->id?>','<?=$this->map->id?>');return false;"><span id="mapycz_marker<?=$item->id?>_shortcut"><?php echo $this->escape($item->shortcut); ?></span></a>
									</td>
									<td align="left">
										<a href="#" onclick="mapycz_editMarker('<?=$item->id?>','<?=$this->map->id?>');return false;"><span id="mapycz_marker<?=$item->id?>_title"><?php echo $this->escape($item->title); ?></span></a>
										<div style="display:none">
											<span id="mapycz_marker<?=$item->id?>_longitude"><?=$item->longitude?></span>,
											<span id="mapycz_marker<?=$item->id?>_latitude"><?=$item->latitude?></span>,
											<span id="mapycz_marker<?=$item->id?>_color"><?=$item->color?></span>
										</div>
									</td>
								</tr>
							<?php endforeach; ?>
						</tbody>
					</table>

					<div>
						<input type="hidden" name="task" value="marker" />
						<input type="hidden" name="boxchecked" value="0" />
						<input type="hidden" name="mapId" value="<?=$this->map->id?>" />
						<input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
						<input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
						<?php echo JHtml::_('form.token'); ?>
					</div>
				</form>
				
			</div>
			<div class="b">
				<div class="b">
					<div class="b"></div>
				</div>
			</div>
		</div>
	</div>
</div>

<script><?//=$js?></script>
